(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('booble-modal', ['exports', '@angular/core', 'rxjs'], factory) :
    (global = global || self, factory(global['booble-modal'] = {}, global.ng.core, global.rxjs));
}(this, (function (exports, core, rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/booble-modal.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BoobleModalService = /** @class */ (function () {
        function BoobleModalService(componentFactoryResolver, applicationRef, injector) {
            this.componentFactoryResolver = componentFactoryResolver;
            this.applicationRef = applicationRef;
            this.injector = injector;
            this.value = new rxjs.BehaviorSubject(null);
            this.isDismissed = false;
        }
        /**
         * @param {?} component
         * @param {?=} data
         * @return {?}
         */
        BoobleModalService.prototype.present = /**
         * @param {?} component
         * @param {?=} data
         * @return {?}
         */
        function (component, data) {
            if (this.componentRef) {
                this.dismiss(null);
            }
            this.isDismissed = false;
            this.componentRef = this.componentFactoryResolver
                .resolveComponentFactory(component)
                .create(this.injector);
            this.applicationRef.attachView(this.componentRef.hostView);
            /** @type {?} */
            var domElem = (/** @type {?} */ (((/** @type {?} */ (this.componentRef.hostView)))
                .rootNodes[0]));
            try {
                this.componentRef.instance.boobleModalData = data;
            }
            catch (error) {
                console.log('Property boobleModalData not found in modal component');
            }
            document.body.prepend(domElem);
            document.getElementsByTagName('html')[0].style.overflow = 'hidden';
            return {
                dismiss: this.dismiss,
                onDidDismiss: this.onDidDismiss,
                isDismissed: this.isDismissed
            };
        };
        Object.defineProperty(BoobleModalService.prototype, "onDidDismiss", {
            get: /**
             * @private
             * @return {?}
             */
            function () {
                return this.value.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} data
         * @return {?}
         */
        BoobleModalService.prototype.dismiss = /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.isDismissed = true;
            this.applicationRef.detachView(this.componentRef.hostView);
            this.componentRef.destroy();
            document.getElementsByTagName('html')[0].removeAttribute('style');
            this.value.next(data);
        };
        BoobleModalService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        BoobleModalService.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector }
        ]; };
        /** @nocollapse */ BoobleModalService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function BoobleModalService_Factory() { return new BoobleModalService(core.ɵɵinject(core.ComponentFactoryResolver), core.ɵɵinject(core.ApplicationRef), core.ɵɵinject(core.INJECTOR)); }, token: BoobleModalService, providedIn: "root" });
        return BoobleModalService;
    }());
    if (false) {
        /** @type {?} */
        BoobleModalService.prototype.componentRef;
        /**
         * @type {?}
         * @private
         */
        BoobleModalService.prototype.value;
        /** @type {?} */
        BoobleModalService.prototype.isDismissed;
        /**
         * @type {?}
         * @private
         */
        BoobleModalService.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @private
         */
        BoobleModalService.prototype.applicationRef;
        /**
         * @type {?}
         * @private
         */
        BoobleModalService.prototype.injector;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/booble-modal.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BoobleModalModule = /** @class */ (function () {
        function BoobleModalModule() {
        }
        BoobleModalModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [],
                        exports: []
                    },] }
        ];
        return BoobleModalModule;
    }());

    exports.BoobleModalModule = BoobleModalModule;
    exports.BoobleModalService = BoobleModalService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=booble-modal.umd.js.map
