import { Injectable, ComponentFactoryResolver, ApplicationRef, Injector, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/booble-modal.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BoobleModalService {
    /**
     * @param {?} componentFactoryResolver
     * @param {?} applicationRef
     * @param {?} injector
     */
    constructor(componentFactoryResolver, applicationRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.value = new BehaviorSubject(null);
        this.isDismissed = false;
    }
    /**
     * @param {?} component
     * @param {?=} data
     * @return {?}
     */
    present(component, data) {
        if (this.componentRef) {
            this.dismiss(null);
        }
        this.isDismissed = false;
        this.componentRef = this.componentFactoryResolver
            .resolveComponentFactory(component)
            .create(this.injector);
        this.applicationRef.attachView(this.componentRef.hostView);
        /** @type {?} */
        const domElem = (/** @type {?} */ (((/** @type {?} */ (this.componentRef.hostView)))
            .rootNodes[0]));
        try {
            this.componentRef.instance.boobleModalData = data;
        }
        catch (error) {
            console.log('Property boobleModalData not found in modal component');
        }
        document.body.prepend(domElem);
        document.getElementsByTagName('html')[0].style.overflow = 'hidden';
        return {
            dismiss: this.dismiss,
            onDidDismiss: this.onDidDismiss,
            isDismissed: this.isDismissed
        };
    }
    /**
     * @private
     * @return {?}
     */
    get onDidDismiss() {
        return this.value.asObservable();
    }
    /**
     * @param {?} data
     * @return {?}
     */
    dismiss(data) {
        this.isDismissed = true;
        this.applicationRef.detachView(this.componentRef.hostView);
        this.componentRef.destroy();
        document.getElementsByTagName('html')[0].removeAttribute('style');
        this.value.next(data);
    }
}
BoobleModalService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
BoobleModalService.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: Injector }
];
/** @nocollapse */ BoobleModalService.ngInjectableDef = ɵɵdefineInjectable({ factory: function BoobleModalService_Factory() { return new BoobleModalService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: BoobleModalService, providedIn: "root" });
if (false) {
    /** @type {?} */
    BoobleModalService.prototype.componentRef;
    /**
     * @type {?}
     * @private
     */
    BoobleModalService.prototype.value;
    /** @type {?} */
    BoobleModalService.prototype.isDismissed;
    /**
     * @type {?}
     * @private
     */
    BoobleModalService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    BoobleModalService.prototype.applicationRef;
    /**
     * @type {?}
     * @private
     */
    BoobleModalService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/booble-modal.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BoobleModalModule {
}
BoobleModalModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [],
                exports: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: booble-modal.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BoobleModalModule, BoobleModalService };
//# sourceMappingURL=booble-modal.js.map
